#ifndef __LARCUTILS_H__
#define __LARCUTILS_H__

#include <string.h>
#include <math.h>
#include "mex.h"
#include "mkl.h"
#include "mkl_lapack.h"

void mcolr(double y[], const double X[], mwIndex n, mwSize d);
void mcolcopy(double A[], mwIndex p, const double B[], mwIndex q, mwSize d);
void melementw(double X[], mwIndex i, mwIndex j, double v, mwSize m);
void mroww(double X[], mwIndex i, mwSize d, const double v[], mwSize l);
void mcolw(double X[], mwIndex i, mwSize d, const double v[]);
void mvprod(double b[], const double A[], mwSize m, mwSize n, const double x[]);

void zeros(double x[], mwSize n);
void vadd(double y[], double a1, const double x1[], double a2, const double x2[], mwSize n);
double vdot(const double x1[], const double x2[], mwSize n);
void vscale(double x[], double a, mwSize k);
void vscalec(double y[], const double x[], double a, mwSize k);
void vindexr(double y[], const double x[], const mwIndex indices[], mwSize k);
void vindexw(double y[], const double x[], const mwIndex indices[], mwSize k);
mwIndex vindexmax(const double x[], mwSize k);
void vsign(double s[], const double x[], mwSize d);

unsigned short int is_index_set_member(mwIndex a, const mwIndex b[], mwSize k);
void index_set_complement(mwIndex complement[], mwSize l, const mwIndex set[], mwSize k);
void solveltr(double w[], double L[], int transposed, const double v[], mwSize k, mwSize l);
void solvecholesky(double b[], double L[], const double x[], mwSize k, mwSize l);

double dmin(const double a, const double b);
void sec2hms(double sec, int *hours, int *minutes, double *seconds);

#endif
