% Compiles LARC toolbox using mex.

%% PATHS

% Change this path to your Intel MKL installation folder
% INCLUDE THE FINAL SLASH.
path_mkl = '/opt/intel/mkl/10.1.2.024/';

%% COMPILATION

compile_cmd = [ ...
    'mex larcmex.c larccore.c larcutils.c -v ' ...
    '-I' path_mkl 'include ' ...
    '-L' path_mkl 'lib/32 ' ...
    path_mkl 'lib/32/libmkl_solver_sequential.a ' ...
    '-Wl,--start-group ' ...
    path_mkl 'lib/32/libmkl_intel.a ' ...
    path_mkl 'lib/32/libmkl_sequential.a ' ...
    path_mkl 'lib/32/libmkl_core.a ' ...
    '-Wl,--end-group ' ...
    '-lpthread' ...
    ];

disp('Building larc...');
unix(compile_cmd);